## autobahn-cpp 0.2.1

=== examples/SConstruct ===
###############################################################################
#
# Copyright (c) Crossbar.io Technologies GmbH and contributors
#
# Boost Software License - Version 1.0 - August 17th, 2003
#
# Permission is hereby granted, free of charge, to any person or organization
# obtaining a copy of the software and accompanying documentation covered by
# this license (the 'Software') to use, reproduce, display, distribute,
# execute, and transmit the Software, and to prepare derivative works of the
# Software, and to permit third-parties to whom the Software is furnished to
# do so, all subject to the following:
#
# The copyright notices in the Software and this entire statement, including
# the above license grant, this restriction and the following disclaimer,
# must be included in all copies of the Software, in whole or in part, and
# all derivative works of the Software, unless such copies or derivative
# works are solely in the form of machine-executable object code generated by
# a source language processor.
#
# THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
# SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
# FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
# DEALINGS IN THE SOFTWARE.
#
###############################################################################

import os, commands

env = Environment()

if 'CXX' in os.environ:
    env['CXX'] = os.environ['CXX']

if 'clang++' in env['CXX']:

    print('Using clang toolchain')

    env.Append(CXXFLAGS=['-std=c++11',
                         '-stdlib=libc++',
                         '-O2',
                         '-Wall',
                         '-pedantic',
                         '-Wno-unused-value',
                         '-Wno-deprecated',
                         '-pthread'])

    env.Append(LINKFLAGS=['-stdlib=libc++', '-pthread'])

elif 'g++' in env['CXX']:

    print('Using GNU toolchain')

    GCC_VERSION = commands.getoutput(env['CXX'] + ' -dumpversion')
    if GCC_VERSION < '4.3.0':
        raise Exception('GCC version {} detected with no or insufficient C++ 11 support detected'.format(GCC_VERSION))

    env.Append(CXXFLAGS=['-std=c++11',
                         '-O2',
                         '-Wall',
                         '-pedantic',
                         '-Wno-deprecated-declarations',
                         '-Wno-unused-local-typedefs',
                         '-Wl,--no-as-needed',
                         '-pthread'])

    env.Append(LINKFLAGS=['-pthread'])

else:
    raise Exception('Uups. The toolchain {} is new to me =('.format(env['CXX']))


env.Append(CPPPATH=['/usr/local/include'])
env.Append(LIBPATH=['/usr/lib'])

examples = [('subscriber.cpp', []),
            ('publisher.cpp', []),
            ('provide_prefix.cpp', []),
            ('callee.cpp', []),
            ('caller.cpp', []),
            ('wampcra.cpp', ['crypto']),
            ('websocket_callee.cpp', ['crypto', 'ssl']),
            ('uds.cpp', [])]

parameters = env.StaticLibrary('parameters', ['parameters.cpp'])

prgs = []

for e, extralibs in examples:
    prgs.append(env.Program(e, LIBS=[
        parameters,
        'boost_thread-mt',
        'boost_system',
        'boost_program_options',
        'msgpackc'] + extralibs))

=== debian/changelog ===
autobahn-cpp (0.2.1-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Force version 1 API for msgpack-c to fix FTBFS against msgpack-c 2.x.
    (Closes: #864465)

 -- James McCoy <jamessan@debian.org>  Sat, 16 Sep 2017 14:07:54 -0400

autobahn-cpp (0.2.1-2) unstable; urgency=medium

  * Build-depend on libssl1.0-dev instead. 

 -- Konstantinos Margaritis <markos@debian.org>  Thu, 16 Feb 2017 20:09:12 +0200

autobahn-cpp (0.2.1-1) unstable; urgency=medium

  * Initial release (Closes: #851575)

 -- Konstantinos Margaritis <markos@debian.org>  Wed, 18 Jan 2017 10:25:44 +0100

=== debian/control ===
Source: autobahn-cpp
Priority: optional
Maintainer: Konstantinos Margaritis <markos@debian.org>
Build-Depends: debhelper (>= 10), cmake, libmsgpack-dev (>= 1.4.2), libwebsocketpp-dev (>= 0.7), libboost-program-options-dev, libboost-thread-dev, libboost-system-dev, libboost-random-dev, libssl1.0-dev
Standards-Version: 3.9.8
Section: libs
Homepage: http://autobahn.ws
#Vcs-Git: https://anonscm.debian.org/collab-maint/autobahn-cpp.git
#Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/autobahn-cpp.git

Package: autobahn-cpp-dev
Section: libdevel
Architecture: all
Depends: ${misc:Depends}, cmake, libmsgpack-dev (>= 1.4.2), libwebsocketpp-dev (>= 0.7), libboost-program-options-dev, libboost-thread-dev, libboost-system-dev, libboost-random-dev, libssl-dev
Description: WAMP in C++ for Boost/Asio - development headers
 Autobahn|Cpp is a subproject of Autobahn which provides a C++ WAMP
 implementation that is able to talk WAMP over stdio pipes.
 .
  * Caller
  * Callee
  * Publisher
  * Subscriber
 .
 Autobahn|Cpp is open-source, licensed under the Boost Software License.
 The API and implementation make use of modern C++ 11 and new asynchronous
 idioms using (upcoming) features of the standard C++ library, in
 particular Futures, Continuations and Lambdas.
 .
 This package includes the header files

Package: autobahn-cpp-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, autobahn-cpp-dev
Description: WAMP in C++ for Boost/Asio - examples
 Autobahn|Cpp is a subproject of Autobahn which provides a C++ WAMP
 implementation that is able to talk WAMP over stdio pipes.
 .
  * Caller
  * Callee
  * Publisher
  * Subscriber
 .
 Autobahn|Cpp is open-source, licensed under the Boost Software License.
 The API and implementation make use of modern C++ 11 and new asynchronous
 idioms using (upcoming) features of the standard C++ library, in
 particular Futures, Continuations and Lambdas.
 .
 This package includes the examples

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DEB_CXXFLAGS_MAINT_APPEND = -DMSGPACK_DEFAULT_API_VERSION=1

%:
	dh $@ --parallel

## autobahn-cpp 17.5.1%2Bgit7cc5d37

=== debian/changelog ===
autobahn-cpp (17.5.1+git7cc5d37-4) unstable; urgency=medium

  * QA upload.

  * Added d/gbp.conf to describe branch layout.
  * Updated vcs in d/control to Salsa.
  * Updated d/gbp.conf to enforce the use of pristine-tar.
  * Updated Standards-Version from 4.6.2 to 4.7.0.
  * Use wrap-and-sort -at for debian control files.
  * Refer to common license file for Apache-2.0.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 22 Oct 2024 07:29:41 +0200

autobahn-cpp (17.5.1+git7cc5d37-3) unstable; urgency=medium

  * QA upload.
  * Set Maintainer to Debian QA Group
  * (Build-)Depends on libmsgpack-cxx-dev instead of libmsgpack-dev. (Closes:
    #1019114)
  * Bump debhelper compat to 13 and use debhelper-compat Build-Depends
  * Set Rules-Requires-Root: no
  * Bump Standards-Version to 4.6.2, no changes needed

 -- James McCoy <jamessan@debian.org>  Sat, 27 Jan 2024 12:58:27 -0500

autobahn-cpp (17.5.1+git7cc5d37-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Add -Wno-error=deprecated-declarations flag. (Closes: #995634)
  * d/control: Remove non-existing Vcs-* fields.

 -- Bastian Germann <bage@debian.org>  Sat, 21 May 2022 20:46:38 +0200

autobahn-cpp (17.5.1+git7cc5d37-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add upstream fix for FTBFS with Boost 1.74. (Closes: #978201)

 -- Adrian Bunk <bunk@debian.org>  Mon, 08 Feb 2021 22:23:04 +0200

autobahn-cpp (17.5.1+git7cc5d37-2) unstable; urgency=medium

  * Include forgotten headers wamp_publish_options.*

 -- Konstantinos Margaritis <markos@debian.org>  Tue, 21 Nov 2017 23:58:08 +0200

autobahn-cpp (17.5.1+git7cc5d37-1) unstable; urgency=medium

  * New upstream version
  * Move to OpenSSL 1.1 (Closes: #858386)
  * Improve description (Closes: #855284)

 -- Konstantinos Margaritis <markos@debian.org>  Tue, 21 Nov 2017 15:32:36 +0200

## autobahn-cpp 17.5.1+git7cc5d37

=== CMakeLists.txt ===
# Use this for installing AutobahnCpp into <prefix>/include.
cmake_minimum_required(VERSION 2.8)

project(autobahn-cpp)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "-stdlib=libc++ -Wno-unused-local-typedefs -Wno-unknown-warning-option ${CMAKE_CXX_FLAGS}")
    if ("${CMAKE_GENERATOR}" STREQUAL "Ninja")
        set(CMAKE_CXX_FLAGS "-fcolor-diagnostics ${CMAKE_CXX_FLAGS}")
    endif()
endif()

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    if(NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.9.0") # i.e. if >= 4.9.0
        if (CMAKE_GENERATOR STREQUAL "Ninja")
            set(CMAKE_CXX_FLAGS "-fdiagnostics-color=always ${CMAKE_CXX_FLAGS}")
        else()
            set(CMAKE_CXX_FLAGS "-fdiagnostics-color=auto ${CMAKE_CXX_FLAGS}")
        endif()
    endif()
endif()

if(NOT MSVC)
    set(CMAKE_CXX_FLAGS "-std=c++11 -Wall -Werror -Wno-unused-variable ${CMAKE_CXX_FLAGS}")
endif()

set(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH}
    "${CMAKE_SOURCE_DIR}/cmake/Modules/")

find_package(Boost REQUIRED COMPONENTS program_options system thread random)
find_package(Websocketpp REQUIRED)
find_package(Msgpack REQUIRED)
find_package(Threads REQUIRED)
find_package(OpenSSL REQUIRED)

set(PUBLIC_HEADERS
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/autobahn.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/boost_config.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/exceptions.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_arguments.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_auth_utils.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_authenticate.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_authenticate.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_call.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_call.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_call_options.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_call_options.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_call_result.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_call_result.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_challenge.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_challenge.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_event.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_event.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_event_handler.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_invocation.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_invocation.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_message.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_message.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_message_type.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_message_type.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_procedure.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_publication.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_publication.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_rawsocket_transport.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_rawsocket_transport.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_register_request.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_register_request.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_registration.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_registration.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_transport.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_transport_handler.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_session.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_session.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_subscribe_options.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_subscribe_options.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_subscribe_request.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_subscribe_request.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_subscription.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_subscription.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_tcp_transport.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_tcp_transport.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_transport_handler.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_transport.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_uds_transport.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_unregister_request.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_unregister_request.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_unsubscribe_request.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_unsubscribe_request.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_websocket_transport.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_websocket_transport.ipp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_websocketpp_websocket_transport.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/autobahn/wamp_websocketpp_websocket_transport.ipp
    )

foreach(h ${PUBLIC_HEADERS})
    string(REPLACE "${CMAKE_CURRENT_SOURCE_DIR}/" "include/" include "${h}")
    get_filename_component(HEADER_INCLUDE_DIRECTORY ${include} DIRECTORY)
    install(FILES ${h}
        DESTINATION ${HEADER_INCLUDE_DIRECTORY}
        COMPONENT "headers")
endforeach()

add_subdirectory(examples)

=== examples/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR} ${Boost_INCLUDE_DIRS} ${OPENSSL_INCLUDE_DIR} ${Websocketpp_INCLUDE_DIRS} ${Msgpack_INCLUDE_DIRS})
link_libraries(${Boost_LIBRARIES} ${OPENSSL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})

set(PARAMETERS_SOURCES parameters.cpp)
set(PARAMETERS_HEADERS parameters.hpp)
add_library(examples_parameters ${PARAMETERS_SOURCES} ${PARAMETERS_HEADERS})

set(CALLER_SOURCES caller.cpp)
set(CALLEE_SOURCES callee.cpp)
set(PROVIDE_PREFIX_SOURCES callee.cpp)
set(PUBLISHER_SOURCES publisher.cpp)
set(SUBSCRIBER_SOURCES subscriber.cpp)
set(WAMPCRA_SOURCES wampcra.cpp)
set(UDS_SOURCES uds.cpp)
set(WEBSOCKET_CALLEE_SOURCES websocket_callee.cpp)

add_executable(caller ${CALLER_SOURCES} ${PUBLIC_HEADERS})
add_executable(callee ${CALLEE_SOURCES} ${PUBLIC_HEADERS})
add_executable(provide_prefix ${PROVIDE_PREFIX_SOURCES} ${PUBLIC_HEADERS})
add_executable(publisher ${PUBLISHER_SOURCES} ${PUBLIC_HEADERS})
add_executable(subscriber ${SUBSCRIBER_SOURCES} ${PUBLIC_HEADERS})
add_executable(wampcra ${WAMPCRA_SOURCES} ${PUBLIC_HEADERS})
add_executable(uds ${UDS_SOURCES} ${PUBLIC_HEADERS})
add_executable(websocket_callee ${WEBSOCKET_CALLEE_SOURCES} ${PUBLIC_HEADERS})

target_link_libraries(caller examples_parameters)
target_link_libraries(callee examples_parameters)
target_link_libraries(provide_prefix examples_parameters)
target_link_libraries(publisher examples_parameters)
target_link_libraries(subscriber examples_parameters)
target_link_libraries(wampcra examples_parameters crypto)
target_link_libraries(uds examples_parameters)
target_link_libraries(websocket_callee examples_parameters crypto ssl)

=== examples/SConstruct ===
--- 
+++ 
@@ -92,7 +92,7 @@
 for e, extralibs in examples:
     prgs.append(env.Program(e, LIBS=[
         parameters,
-        'boost_thread-mt',
+        'boost_thread',
         'boost_system',
         'boost_program_options',
         'msgpackc'] + extralibs))

=== debian/changelog ===
autobahn-cpp (17.5.1+git7cc5d37-5) unstable; urgency=medium

  * QA upload.
  * Bump CMake policy version (Closes: #1112712)
  * Bump Standards-Version to 4.7.2

 -- Timo Röhling <roehling@debian.org>  Wed, 24 Sep 2025 21:47:33 +0200

=== debian/control ===
Source: autobahn-cpp
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libboost-program-options-dev,
               libboost-random-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libmsgpack-cxx-dev,
               libssl-dev,
               libwebsocketpp-dev (>= 0.7),
Standards-Version: 4.7.2
Rules-Requires-Root: no
Section: libs
Homepage: http://autobahn.ws
Vcs-Browser: https://salsa.debian.org/debian/autobahn-cpp
Vcs-Git: https://salsa.debian.org/debian/autobahn-cpp.git

Package: autobahn-cpp-dev
Section: libdevel
Architecture: all
Depends: cmake,
         libboost-program-options-dev,
         libboost-random-dev,
         libboost-system-dev,
         libboost-thread-dev,
         libmsgpack-cxx-dev,
         libssl-dev,
         libwebsocketpp-dev (>= 0.7),
         ${misc:Depends},
Description: WAMP in C++ for Boost/Asio - development headers
 Autobahn|Cpp provides an implementation of the WebSocket and Web
 Application Messaging (WAMP) protocols.
 .
 WebSocket allows bidirectional real-time messaging on the Web and
 WAMP adds asynchronous Remote Procedure Calls and Publish &
 Subscribe on top of WebSocket.
 .
 Autobahn|Cpp is open-source, licensed under the Boost Software
 License. The API and implementation make use of modern C++ 11 and
 new asynchronous idioms using (upcoming) features of the standard
 C++ library, in particular Futures, Continuations and Lambdas.
 .
 This package includes the header files

Package: autobahn-cpp-doc
Section: doc
Architecture: all
Depends: autobahn-cpp-dev,
         ${misc:Depends},
Description: WAMP in C++ for Boost/Asio - examples
 Autobahn|Cpp provides an implementation of the WebSocket and Web
 Application Messaging (WAMP) protocols.
 .
 WebSocket allows bidirectional real-time messaging on the Web and
 WAMP adds asynchronous Remote Procedure Calls and Publish &
 Subscribe on top of WebSocket.
 .
 Autobahn|Cpp is open-source, licensed under the Boost Software
 License. The API and implementation make use of modern C++ 11 and
 new asynchronous idioms using (upcoming) features of the standard
 C++ library, in particular Futures, Continuations and Lambdas.
 .
 This package includes the examples

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export DEB_CXXFLAGS_MAINT_APPEND = -DMSGPACK_DEFAULT_API_VERSION=1 -Wno-error=deprecated-declarations

%:
	dh $@
